function [t,Tx] = SynchroComplet(Fb,Fc,cas)
%% function sqt1 : computes the synchrosqueezing transform of signal s

%si cas = 1, on utilise l'ondelette de Morlet
%si cas =2, on utilise l'ondelette Bump

t=0:1/1023:1;
dt=1/1023;
s = cos(2*pi*40*t);

nv = 32; % nbre coefs par octave
N = length(s);
noct = log2(N)-1;
na = noct*nv;
if (cas == 2) 
 j0 = nv*((log(2)+log(Fc+Fb))/log(2)); %voir explication pour j0
else
 Delta = sqrt(log(2)/(2*Fb*pi^2));    
 j0 = nv*(log(2)+log(Delta+Fc));
end

as = (2^(1/nv).^(j0:1:na-1));
as1 = as*dt;
T = t(end);

lfm = (0:N-1)/T;

fts = fft(s); %on veut avoir le meme resultat independamment de la taille du signal
Las = length(as);
Wbb = zeros(Las,N);

for j = 1:Las,
 if (cas == 2)
  for k=1:length(lfm)
    if k == 1,
      if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
         FouPsi = exp(1-(1/(1-((as1(j)*lfm(k)-Fc)/Fb)^2)));
      else
         FouPsi = 0;  
      end
    else
      if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
          FouPsi = [FouPsi exp(1-(1/(1-((as1(j)*lfm(k)-Fc)/Fb)^2)))];
      else
          FouPsi = [FouPsi 0];  
      end
    end
  end
 else
  for k=1:length(lfm)  
   if k == 1,
     FouPsi = exp(-Fb*pi^2*(as1(j)*lfm(k)-Fc)^2);
   else
     FouPsi = [FouPsi exp(-Fb*pi^2*(as1(j)*lfm(k)-Fc)^2)];
   end
  end
 end 
 Wb = ifft(fts.*FouPsi);
 Wbb(j,:) = Wb;
end

%% Reconstruction
Tx = zeros(1,N);

for b=1:N 
    Tx(b) = sum(Wbb(:,b)*log(2)/nv);
end

if cas == 2
 CPsi = quadgk(@(x)PsiHat(x,Fc,Fb),Fc-Fb,Fc+Fb);
else
 CPsi = quadgk(@(x)PsiMor(x,Fc,Fb),0,inf);  
end

Tx = real(Tx)/CPsi;

end

