function [as,omega,t,Tx,s]=SynchroOmega(Fb,Fc,cas,gamma,s)
%% function sqt1 : computes the synchrosqueezing transform of signal s

%On considere la transformation avec l'ondelette bump

%cas = 1, ondelette de Morlet, cas = 2, ondelette Bump
%Parameters
%gamma = 0.01; % Seuil pour wavelet thresholding

t=0:1/1023:1;
dt=1/1023;
%s = cos(2*pi*40*t)+cos(2*pi*32.72*t); 
%s = cos(2*pi*30*(t+1/4).^2)+cos(2*pi*24.55*(t+1/4).^2); 

nv = 32; % nbre coefs par octave
N = length(s);
noct = log2(N)-1;
na = noct*nv;
if (cas == 2)||(cas == 3),
 j0 = nv*((log(2)+log(Fc+Fb))/log(2)); %voir explication pour j0
else
 Delta = sqrt(log(2)/(2*Fb*pi^2));    
 j0 = nv*(log(2)+log(Delta+Fc));
end

as = (2^(1/nv).^(j0:1:na-1));
as1 = as*dt;
T = t(end);

%les frequences pour la TF
lfm = (0:N-1)/T;

fts = fft(s); %on veut avoir le meme resultat independamment de la taille du signal
Las = length(as);
Wbb = zeros(Las,N);
omega = zeros(Las,N);

%Transformee de Fourier de l'ondelette Bump

for j = 1:Las,
 if cas == 2,
  for k=1:length(lfm)
   if k == 1,
      if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
         FouPsi = exp(1-(1/(1-((as1(j)*lfm(k)-Fc)/Fb)^2)));
      else
         FouPsi = 0;  
      end
   else
      if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
          FouPsi = [FouPsi exp(1-(1/(1-((as1(j)*lfm(k)-Fc)/Fb)^2)))];
      else
          FouPsi = [FouPsi 0];      
      end
   end
  end
  
 elseif cas == 3,
   for k=1:length(lfm)  
    if k == 1,
     if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
         FouPsi = 1;
     else
         FouPsi = 0;  
     end
    else
     if abs((as1(j)*lfm(k)-Fc)/Fb) < 1
       FouPsi = [FouPsi 1];
     else
       FouPsi = [FouPsi 0];      
     end
    end
   end 
 else
  for k=1:length(lfm)  
   if k == 1,
     FouPsi = exp(-Fb*pi^2*(as1(j)*lfm(k)-Fc)^2);
   else
     FouPsi = [FouPsi exp(-Fb*pi^2*(as1(j)*lfm(k)-Fc)^2)];
   end
  end
 end 
 %We compute omega_2, cosidering only the coefficient larger than gamma
 Wbder = ifft(lfm.*(fts.*FouPsi));
 Wb = ifft(fts.*FouPsi);
 
 Wbb(j,:) = Wb;
 for k=1:length(t),
  if (abs(Wb(k))> gamma)
    omega(j,k) = abs(Wbder(k)/Wb(k));
  else
    omega(j,k) = 0;
  end
 end
end

 %figure()
 %imagesc(abs(Wbb))
 %as = (2^(1/nv).^(1:1:na-1));
 %Wbb = cwt(s,as,'cmor100-1');
 %figure()
 %imagesc(abs(Wbb))
 %pause

 %on utilise une formule d'ordre 2 pour calculer la derivee
 %Wbr = [Wbb(:, end-1:end) Wbb Wbb(:, 1:2)];
 %w = -Wbr(:, 5:end);
 %w = w + 8*Wbr(:, 4:end-1);
 %w = w - 8*Wbr(:, 2:end-3);
 %w = w + Wbr(:, 1:end-4);
 %w = w / (12*dt);lfm = log2(fm); lfM = log2(fM);

 %w = -imag(w ./ Wbb / (2*pi));
 %w((abs(Wbb) < gamma)) = 0;
 %omega = w;
 %plot(as,omega(:,30))
 %pause

%Synchrosqueezing transform

Tx = zeros(Las,N);
linfm = Fc./as1;
for b=1:N 
    for j=1:Las
       if (abs(Wbb(j,b)) > gamma) % on recherche a quelle boite frequentielle appartient omega(i,N)
        [Y k] = min(abs(linfm-omega(j,b)));
        Tx(k,b) = Tx(k,b) + real(Wbb(j,b))*log(2)/nv;           
       end
    end
end

if cas == 2,
 CPsi = quadgk(@(x)PsiHat(x,Fc,Fb),Fc-Fb,Fc+Fb);
elseif cas == 3,
 CPsi = quadgk(@(x)PsiConst(x),Fc-Fb,Fc+Fb);   
else    
 CPsi = quadgk(@(x)PsiMor(x,Fc,Fb),0,inf);  
end
Tx = Tx/CPsi; 

%contour(t,Fc./as1,abs(Tx));
%set(gca,'YDir','normal');
%set(gca,'YTick',linspace(lfm(1),lfm(end),10),'YTickLabel',2*lfm(floor(1:(length(lfm)/10):end)));

